/****************************************
*  ^b`XCb`gQ[
*  J[}b`Q[
***************************************/
#include  <16f726.h>
#include <stdlib.h>
#fuses HS,NOWDT,NOPROTECT,PUT,BROWNOUT,MCLR,NODEBUG,BORV25,VCAP_A0
#use fast_io(A)
#use fast_io(B)
#use fast_io(C)
#use delay(CLOCK = 20000000)
// WX^ݒ
#byte OPTION = 0x081					// Timer0
#byte TMR0   = 0x001
#bit  T0IF   = 0x00B.2					// INTCON bit2
#byte T1CON  = 0x010					// Timer1
#byte T1GCON = 0x08F
#byte TMR1H  = 0x00F
#byte TMR1L  = 0x00E
#bit  TMR1GIF= 0x00C.7					// PIR1 bit7
#bit  T1GGO  = 0x08F.3					// T1GCON bit 3
#byte T2CON  = 0x012					// Timer2
#byte TMR2   = 0x011
#byte PR2    = 0x092
#bit  TMR2IE = 0x08C.1					// PIE1 bit1
#bit  TMR2IF = 0x00C.1					// PIR1 bit1
#byte INTCON = 0x00B
#byte CPSCON0= 0x108					// CSM
#byte CPSCON1= 0x109					// select channel
#byte PORTC  = 0x007					// Ports
#byte ANSELA = 0x185
#byte ANSELB = 0x186
// O[oϐA萔錾
unsigned long Trip, Freq[8], Norm[8] = {0,0,0,0,0,0,0,0};
unsigned int Period, Width[6] = {0,0,0,0,0,0}, WidthSet[6]={0,0,0,0,0,0};
unsigned int Game, Level, Maxim, Max[4] = {0x03,0x07,0x0F,0x1F}, j;
// ֐vg^Cv
unsigned long ReadFreq(unsigned int channel);
unsigned int TouchSW(unsigned int SW);
void Update(signed int updown, unsigned int Pin);
void interval(void);

/******************************************
* ^C}Q荞ݏ
*  250usec̊荞
*  PWM̃f[eB̐
******************************************/
#INT_TIMER2
void interval(void)
{
	// f[eBXV
	for(j=0; j<6; j++){	
		if(Width[j] > 0)					// f[eB0ȏ̏ꍇ
			Width[j]--;					// f[eBJEg
		if(Width[j] == 0){				// f[eBH
			bit_clear(PORTC, j);			// LEDIt
		}
	}
	// XV
	Period--;							// JEg
	if(Period == 0){						// H
		for(j=0; j<6; j++){
			Width[j] = WidthSet[j];		// f[eBlZbg
			if(Width[j] > 0)				// f[eB0ȏ̏ꍇ̂
				bit_set(PORTC, j);		// LEDI
		}
		Period = Maxim * 2;				// Đݒ
	}
	TMR2IF = 0;
}

/************* C֐ *********************/
void main()
{
	int i, Chan, Match, Base;

	// |[gݒ	
	output_A(0xFF);
	output_C(0);
	output_B(0xFF);
	set_tris_A(0xFF);						// SsSW 
	set_tris_C(0);						// SsLEDo
	set_tris_B(0xFF);						// SsSW
	ANSELA = 0x3F;						// AiOsw
	ANSELB = 0x3F;
	// ^C}Qݒ PWMp@0.2usec*250*1*5 ->250usec
	TMR2 = 0;
	T2CON = 0x24;							// 00100100
	PR2 = 0xF9;							// 249
	TMR2IF = 0;
	TMR2IE = 1;	
	// ^C}Pݒ@CSMpgJE^
	T1CON = 0xC5;							// 11000101 1:1
	T1GCON = 0xF1;						// 11100001 Gated by timer0 toggle
	TMR1H = 0;							// clear
	TMR1L = 0;
	// CSMݒ
	CPSCON0 = 0x8C;						// 10001100 high current
	// ^C}0ݒ 5MHz/256 *256-> 13.1msec
	TMR0 = 0;
	OPTION = 0xC7;						// 11000101 T0CS=0
	TMR1GIF = 0;
	// 	^b`XCb`l
	for(i=0; i<5; i++){
		for(Chan=0; Chan<8; Chan++)
			Norm[Chan] += ReadFreq(Chan) / 5;
	}
	// ϐ
	Level = 0;
	Trip = 0x200;	
	Maxim = Max[Level];
	Period = Maxim * 2;
	// 荞݋
	INTCON = 0xC0;
	
	/************** C[v ********************/
	while(1)	
	{		
		output_high(PIN_C6);				// uU[Z
		delay_ms(50);
		output_low(PIN_C6);
		delay_ms(50);		
		output_high(PIN_C6);				// uU[Z
		delay_ms(50);
		output_low(PIN_C6);		
		// ڕWF_ɐݒ
		Maxim = Max[Level];				// level set	
		Period = Maxim * 2;	
		Base = rand();
		srand(Base);
		for(i=0; i<3; i++)
			WidthSet[i+3] = rand() & Maxim;
		// Q[Jn
		Game = 1;						// Q[tOI		
		while(Game){	
			// ^b`XCb`ɂJ[ύX
			if(TouchSW(0))				// ԃAbv
				Update(1, 0);
			if(TouchSW(1))				// ԃ_E
				Update(-1, 0);
			if(TouchSW(2))				// ΃Abv
				Update(1, 1);
			if(TouchSW(3))				// ΃_E
				Update(-1, 1);
			if(TouchSW(4))				// Abv
				Update(1, 2);
			if(TouchSW(5))				// _E
				Update(-1, 2);
			delay_ms(10);					// 10msecx							
			// J[v@svȂJԂ
			Match = 1;					// vtOI
			for(i=0; i<3; i++){
				if(WidthSet[i] != WidthSet[i+3]) 
					Match = 0;			// svZbg
			}
			if(Match){					// vH
				output_high(PIN_C6);		// uU[
				delay_ms(1000);
				Game = 0;				// Q[I
				Match = 0;
				output_low(PIN_C6);
			}
		}
		// 3iK̃xݒƃQ[ĊJ
		while(!TouchSW(7))				// SW7IōĊJ
		{
			if(TouchSW(6)){				// SW6IH
				Level++;					// xAbv
				if(Level == 3)
					Level = 0;			// xZbg
				output_high(PIN_C6);		// uU[I
				if(Level == 0)
					delay_ms(50);			// Z
				if(Level == 1)
					delay_ms(200);		// 
				if(Level == 2)
					delay_ms(400);		// 
				output_low(PIN_C6);		// uU[It
			}				
		}
	}
}
/***********************************
* FXVTu֐
***********************************/
void Update(signed int updown, unsigned int Pin)
{
	if((updown > 0) && (WidthSet[Pin] < Maxim))
		WidthSet[Pin]++;					// őȉȂAbv
	if((updown < 0) && (WidthSet[Pin] > 0))
		WidthSet[Pin]--;					// ŏłȂ΃_E
	output_high(PIN_C6);					// uU[Z
	delay_ms(50);							// XCb`쉹
	output_low(PIN_C6);	
}
/*****************************************
*  ^b`XCb`̓Tu֐
*@@p[^FXCb`ԍ
*@@߂lG0,1
*****************************************/
unsigned int TouchSW(unsigned int SW)
{
	unsigned long Fread;
	
	Fread = ReadFreq(SW);					// ݒl
	if(Fread < Norm[SW] - Trip)			// XCb`
		return(1);						// XCb`I
	else{
		Norm[SW]	= (Norm[SW]+Fread)/2;		// l␳
		return(0);						// XCb`It
	}
}
/*****************************************
*  ^b`XCb`g擾Tu֐
*   p[^F`lԍ
*****************************************/
unsigned long ReadFreq(unsigned int channel)
{
	unsigned long freq;

	CPSCON1 = channel;			// `lI			
	T1CON = 0;					// ^C}P~
	TMR1H = 0;					// ^C}NA
	TMR1L = 0;
	T1CON = 0xC5;					// ^C}PăX^[g
	T1GGO = 1;					// ^C}Q[gL
	while(!TMR1GIF);				// Q[g҂
	TMR1GIF = 0;
	freq = (long)TMR1H * 256;		// ^C}l擾
	freq += (long)TMR1L;
	return(freq);				// glԂ
}


