/**********************************************************
* CTMUg^b`ZTƃRfTeʌv
*  SW1FeXg[hsiivJԂAZbgŖ߂j
*  SW2F[␳l擾
*  SW3FdW؂ւi背W؂ւj
**********************************************************/
#include <p18f24j11.h>
#include <delays.h>
#include <lcdlib18.h>
/* RtBM[V̐ݒ  HSPLL 40MHz */
#pragma config OSC=HSPLL, T1DIG=OFF, LPT1OSC=OFF, FCMEN=OFF, IESO=OFF
#pragma config WDTEN=OFF, XINST=OFF, DSBOREN=ON, DSWDTEN=OFF
#pragma config IOL1WAY=OFF, WPDIS=OFF, CP0=OFF
/* ϐA萔`@*/
float Unit, Capa, Span, Offset, Q;
unsigned int StartFlag, ErrFlag;
unsigned int ChargeTime, Trip, Interval;
unsigned int Norm[3]={0, 0, 0};
unsigned char Range, TestMode;
enum _State{					// ԑJڒ萔
	Idle = 0,
	Wait = 1,
	Calibrated = 2,
	Mesuring = 3
} State;
/* bZ[W̒` */
char StartMsg[] = "Start!          ";
char CapaMsg[]  = "C= xxxxxx pF    ";
char NumMsg[]   = "                ";
char RngMsg[]   = "Range= x        ";
char ErrMsg[]   = "Error!!         ";
char OpenMsg[]  = "Release any Cap!";
char OKMsg[]    = "Get Offset OK!  ";
char TestMsg[]  = "Test Mode       ";
/* ֐vg^CsO@@*/
float GetChargeVolt(unsigned int Cur, unsigned char Chan, unsigned int Charge);
unsigned int TouchSW(unsigned char Chan);
void itostring(char digit, unsigned int data, char *buffer);
void ftostring(int seisu, int shousu, float data, char *buffer);
void Test(void);

/************* C֐@******************/
void main (void){
	int i, j;
	float Temp;
	
	// o͐ݒ
	LATC = 0;								// LCDSIt
	TRISC = 0;								// PORTCo͐ݒ
	LATB = 0x0;								// LED Off
	TRISB = 0;								// LED port
	LATA = 0;								// AiO̓|[g
	TRISA = 0;								// o͂ŕd
	TRISA = 0xFF;								// S͂Ƃ					
	// CTMU Edge1Ń}jAgK
	CTMUCONH = 0x00;							// 10001110
	CTMUCONL = 0x90;							// 11011100
	CTMUICON = 0x01;							// Normal x1(0.55uA)
	// A/DRo[^ݒ
	ADCON1 = 0x8E;							// 10001110 Right,2Tad, 1/64
	ANCON0 = 0xE0;							// AN0-4 enable
	ANCON1 = 0x1F;							// 10011111 GAP Off AN8-12 off
	ADCON0 = 0x09;							// 00001001 AN2 ADON
	// ^b`XCb`ݒ
	StartFlag = 1;							// tOZbg
	for(j=0; j<5; j++){
		for(i=0; i<3; i++)					// XCb`l 5񕽋
			Norm[i] += TouchSW(i) / 5;			// l̓ǂݍ
	}
	StartFlag = 0;							// tONA
	// eϐlݒ	
	State = Idle;								// ԑJڕϐ			
	Trip = 20;								// XCb`XbVh
	Range = 3;								// CTMUd{@x100
	ChargeTime = 1000;						// [dԁ@usec
	Offset = 0;								// eʃItZbg
	Span = 0;								// eʌvZP
	Interval = 50;							// 񐔏l
	TestMode = 0;
	// CTMȔr@e15000pF
	for(i=0; i<5; i++)
		Span += GetChargeVolt(Range, 1, ChargeTime) / 5;
	Q = 15000.0 * Span;
	// JnbZ[W\Al\
	lcd_init();								// LCD
	lcd_str(StartMsg);
	Delay10KTCYx(500);						//0.5sec wait
	
	/*********** C[v *************/
	while(1) {
		/******** ^b`XCb``FbN ************/				
		TouchSW(0);							// SW1_~[XCb`
		// [hؑ
		if(TouchSW(0)){
			/******* eXg[h̎s@*******/
			TestMode = 1;						// [htOI
			lcd_cmd(0x80);
			lcd_str(TestMsg);					// eXgJnbZ[W\
			Delay10KTCYx(500);				// 0.5sec\
			while(1){
				Test();						// eXg[hs
				Delay10KTCYx(50);				// ivJԂ
			}				
		}				
		TouchSW(0);							// SW1_~[XCb`			
		// rv
		if(TouchSW(1)){						// SW2
			LATBbits.LATB5 = 1;				// ڈ
			// ItZbg擾
			lcd_cmd(0x80);					// 1s
			lcd_str(OpenMsg);					// ӃbZ[W\
			Delay10KTCYx(500);				// 0.5sec wait
			Offset = 0;						// 
			Span = 0;
			// ĺ@RfT15000pF
			for(i=0; i<5; i++)
				Span += GetChargeVolt(1, 1, 50) / 5;
			Q = 15000.0 * Span;
			// [q̃ItZbgeʌv					
			for(i=0; i<5; i++){
				Temp = Q / GetChargeVolt(1, 0, 50);
				Offset += Temp / 5;
			}
			lcd_cmd(0xC0);					// 2s
			lcd_str(OKMsg);					// bZ[W\
			Delay10KTCYx(500);				// 0.5sec wait
			State = Idle;						// State				
		}
		TouchSW(0);							// SW1_~[				
		// WύXv
		if(TouchSW(2)){
			switch(Range){
				case 1: Range++;				// WXV
						ChargeTime = 1000;	// [dԐݒ
						break;
				case 2: Range++;				// WXV
						ChargeTime = 500;		// [dԐݒ
						break;
				case 3: Range = 1;			// W
						ChargeTime = 50;		// [dԐݒ
						break;
				default: break;
			}
			itostring(1, Range, RngMsg+7);		// W\
			lcd_cmd(0x80);					// 1s
			lcd_str(RngMsg);
			Delay10KTCYx(100);				// 0.1sec wait
			State = Idle;						// State
		}
		/****** eʌv̎s  Xe[gɂis *********/		
		switch(State){
			// rAWύXƂɎs
			case Idle:
				LATBbits.LATB5 = 1;			// LEDڈ			
				Span = 0;					// Pʐݒ
				for(i=0; i<5; i++)
					Span += GetChargeVolt(Range, 1, ChargeTime) / 5;
				Q = 15000.0 * Span;
				LATBbits.LATB5 = 0;
				State = Wait;
				break;
			// ҂ 0.2bŗeʑ
			case Wait:
				Interval--;
				if(Interval == 0){
					Interval = 50;
					State = Calibrated;
				}
				break;
			// vs
			case Calibrated:	
				LATBbits.LATB4 ^= 1;			// LEDڈ_
				// eʌv
				Capa = 0;					// veʏ
				for(i=0 ;i<5; i++){
					Temp = Q / GetChargeVolt(Range, 0, ChargeTime);
					Capa += Temp / 5;
				}
				Capa -= Offset;				// ItZbgl␳
				ftostring(6, 0, Capa, CapaMsg + 3);
				itostring(1, Range, RngMsg+7);	// W\
				lcd_cmd(0x80);				// 1s
				lcd_str(RngMsg);				
				lcd_cmd(0xC0);				// 2s
				// d͈͒Error\
				if(ErrFlag)
					lcd_str(ErrMsg);			// WI[o[
				else
					lcd_str(CapaMsg);			// \
				State = Wait;
				break;

			default: break;
		}
	}
}
	 	
/***************************************
* ^b`XCb`̓Tu֐
*@p[^SWԍ
***************************************/
unsigned int TouchSW(unsigned char SW)
{
	unsigned int Vread;
	
	// XCb`[dd
	// [dԂ͗viTest()֐g)	
	Vread = (unsigned int)GetChargeVolt(1, SW+2, 35);
	// JntOŕԂlύX
	if(StartFlag)
		return(Vread);					// dlԂ
	// XCb` eXg͓dl߂
	else{
		if(Vread < (Norm[SW] - Trip)){		// ͔
			if(TestMode)
				return(Vread);
			else
				return(1);				// OnԂ
		}
		else{
			Norm[SW] = (Norm[SW]+Vread)/2;	// l␳
			if(TestMode)
				return(Vread);
			else
				return(0);				// OffԂ
		}
	}
}
/***************************************
*  CTMU Tu֐
*   Parameter1 FCTMUdW
*   Parameter2 FAN̓`lԍ
*   Parameter3 F[d(usec)
*   ߂l@@ Fd
***************************************/
float GetChargeVolt(unsigned int Cur, unsigned char Chan, unsigned int Charge)
{
	float Volt;
	
	// CTMU Edge1}jAgK
	CTMUICON = Cur;						// dWݒ 	
	// select AN channel
	ADCON0 = 0x01 + (Chan << 2);			// select AN1 channel, Enable
	// discharge
	CTMUCONHbits.CTMUEN = 1;				// enable CTMU	
	CTMUCONLbits.EDG1STAT = 0;				// gKZbg
	CTMUCONLbits.EDG2STAT = 0;
	CTMUCONHbits.IDISSEN = 1;				// dJn
	Delay10TCYx(1000);					// 1msecԕd
	CTMUCONHbits.IDISSEN = 0;				// dI
	// [dJn
	CTMUCONLbits.EDG1STAT = 1;				// [dJn
	Delay10TCYx(Charge);					// [dԑ҂
	CTMUCONLbits.EDG1STAT = 0;				// [dI
	// dv
	PIR1bits.ADIF = 0;					// A/D荞݃Zbg
	ADCON0bits.GO = 1;					// A/DϊJn
	while(!PIR1bits.ADIF);				// ϊI҂
	// ͓d͈͐@ُ͈͈Error\
	if((ADRES > 950)||(ADRES < 15))			// d̏㉺`FbN
		ErrFlag = 1;						// ㉺I[o̓G[
	else								// ȏꍇ
		ErrFlag = 0;						// G[Zbg
	Volt = (float)ADRES;					// ϊʓd擾
	CTMUCONHbits.CTMUEN = 0;				// CTMU	
	return(Volt);						// dԂ
}
/*********************************************
* Touch SW̃eXgpTu֐
* @XCb`̑dLCDɕ\
*   𒴂Ȃ悤ɏ[dԂ𒲐
*********************************************/
void Test(void)
{
	int i;
	unsigned int Vread;

	LATBbits.LATB4 ^= 1;					// ڈLED_
	// XbVhlϊ
	for(i=0; i<3; i++){
		itostring(3, Norm[i], NumMsg+(i*4));
		NumMsg[13+i] = ' ';				// 蕔
	}
	lcd_cmd(0x80);						// 1sڂɕ\
	lcd_str(NumMsg);
	// Ɠdl̕ϊ	 	
	for(i=0; i<3; i++){
		Vread = (unsigned int)TouchSW(i);	// 
		itostring(3, Vread, NumMsg+(i*4));	// ϊ
		if(Vread < (Norm[i] - Trip))		// ͔
			NumMsg[13+i] = '1';			// I
		else
			NumMsg[13+i] = '0';			// It
	}
	lcd_cmd(0xC0);
	lcd_str(NumMsg);						// Qsڂɕ\
}	 			
/***************************************
* ASCIIɕϊ
****************************************/
void itostring(char digit, unsigned int data, char *buffer)
{
	char i;
	buffer += digit;						// Ō̐ʒu
	for(i=digit; i>0; i--) {				// ϊ͉ʂʂ
		buffer--;						// |C^[P
		*buffer = (data % 10) + '0';		// ASCII
		data = data / 10;					// ̌
	}
}
/***************************************
* Float當֕ϊ
*@vL8ȉƂ邱
****************************************/
void ftostring(int seisu, int shousu, float data, char *buffer)
{
	int i;
	long dumy;

	if(shousu != 0)						//肩
		buffer += seisu+shousu+1;			//Š{_
	else								//Ȃ̂Ƃ
		buffer += seisu + shousu;			//Š̂
	buffer--;							//z|C^-1
	for(i=0; i<shousu; i++)				//𐮐ɕϊ
		data = data * 10;					//PO{
	/// dumyI[o[t[ƕϊs(WE)
	dumy = (long) (data + 0.5);			//ľܓĐɕϊ
	for(i=shousu; i>0; i--)	{			//JԂ
		*buffer =(dumy % 10)+'0';			//l𕶎ɕϊi[
		buffer--;						//i[ꏊʂʂ
		dumy /= 10;						//̌
	}
	if(shousu != 0) {						//0Ȃ珬_Ȃ
		*buffer = '.';					//_i[
		buffer--;						//|C^-1
	}
	for(i=seisu; i>0; i--) {				//JԂ
		*buffer = (dumy % 10)+'0';			//l𕶎ɕϊi[
		buffer--;						//|C^-1
		dumy /= 10;						//̌
	}
	i = 0;								// uLO
	buffer++;
	while((i<seisu)&&(*buffer == '0'))		// ʌ0̊
	{
		*buffer = ' ';					// uNɕϊ
		buffer++;
		i++;
	}
} 
